<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:07 AEST 2019 -->
<title>Expression (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Expression (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":10,"i2":10,"i3":10,"i4":10,"i5":9,"i6":10,"i7":10,"i8":10,"i9":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/internal/expression/ExpressionException.html" title="class in com.sk89q.worldedit.internal.expression"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/internal/expression/Expression.html" target="_top">Frames</a></li>
<li><a href="Expression.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit.internal.expression</div>
<h2 title="Class Expression" class="title">Class Expression</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.internal.expression.Expression</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">Expression</span>
extends java.lang.Object</pre>
<div class="block">Compiles and evaluates expressions.

 <p>Supported operators:</p>

 <ul>
     <li>Logical: &amp;&amp;, ||, ! (unary)</li>
     <li>Bitwise: ~ (unary), &gt;&gt;, &lt;&lt;</li>
     <li>Arithmetic: +, -, *, /, % (modulo), ^ (power), - (unary), --, ++ (prefix only)</li>
     <li>Comparison: &lt;=, &gt;=, &gt;, &lt;, ==, !=, ~= (near)</li>
 </ul>

 <p>Supported functions: abs, acos, asin, atan, atan2, cbrt, ceil, cos, cosh,
 exp, floor, ln, log, log10, max, max, min, min, rint, round, sin, sinh,
 sqrt, tan, tanh and more. (See the Functions class or the wiki)</p>

 <p>Constants: e, pi</p>

 <p>To compile an equation, run
 <code>Expression.compile("expression here", "var1", "var2"...)</code>.
 If you wish to run the equation multiple times, you can then optimize it,
 by calling <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#optimize--"><code>optimize()</code></a>. You can then run the equation as many times
 as you want by calling <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#evaluate-double...-"><code>evaluate(double...)</code></a>. You do not need to
 pass values for all variables specified while compiling.
 To query variables after evaluation, you can use
 <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#getVariable-java.lang.String-boolean-"><code>getVariable(String, boolean)</code></a>. To get a value out of these, use
 <a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/Variable.html#getValue--"><code>Variable.getValue()</code></a>.</p>

 <p>Variables are also supported and can be set either by passing values
 to <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#evaluate-double...-"><code>evaluate(double...)</code></a>.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html" title="class in com.sk89q.worldedit.internal.expression">Expression</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#compile-java.lang.String-java.lang.String...-">compile</a></span>(java.lang.String&nbsp;expression,
       java.lang.String...&nbsp;variableNames)</code>&nbsp;</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#evaluate-double...-">evaluate</a></span>(double...&nbsp;values)</code>&nbsp;</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#evaluate-double:A-int-">evaluate</a></span>(double[]&nbsp;values,
        int&nbsp;timeout)</code>&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/ExpressionEnvironment.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">ExpressionEnvironment</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#getEnvironment--">getEnvironment</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/Functions.html" title="class in com.sk89q.worldedit.internal.expression.runtime">Functions</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#getFunctions--">getFunctions</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>static <a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html" title="class in com.sk89q.worldedit.internal.expression">Expression</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#getInstance--">getInstance</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/RValue.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">RValue</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#getVariable-java.lang.String-boolean-">getVariable</a></span>(java.lang.String&nbsp;name,
           boolean&nbsp;create)</code>&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#optimize--">optimize</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#setEnvironment-com.sk89q.worldedit.internal.expression.runtime.ExpressionEnvironment-">setEnvironment</a></span>(<a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/ExpressionEnvironment.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">ExpressionEnvironment</a>&nbsp;environment)</code>&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html#toString--">toString</a></span>()</code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="compile-java.lang.String-java.lang.String...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>compile</h4>
<pre>public static&nbsp;<a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html" title="class in com.sk89q.worldedit.internal.expression">Expression</a>&nbsp;compile(java.lang.String&nbsp;expression,
                                 java.lang.String...&nbsp;variableNames)
                          throws <a href="../../../../../com/sk89q/worldedit/internal/expression/ExpressionException.html" title="class in com.sk89q.worldedit.internal.expression">ExpressionException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/internal/expression/ExpressionException.html" title="class in com.sk89q.worldedit.internal.expression">ExpressionException</a></code></dd>
</dl>
</li>
</ul>
<a name="evaluate-double...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>evaluate</h4>
<pre>public&nbsp;double&nbsp;evaluate(double...&nbsp;values)
                throws <a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></code></dd>
</dl>
</li>
</ul>
<a name="evaluate-double:A-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>evaluate</h4>
<pre>public&nbsp;double&nbsp;evaluate(double[]&nbsp;values,
                       int&nbsp;timeout)
                throws <a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></code></dd>
</dl>
</li>
</ul>
<a name="optimize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>optimize</h4>
<pre>public&nbsp;void&nbsp;optimize()
              throws <a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/EvaluationException.html" title="class in com.sk89q.worldedit.internal.expression.runtime">EvaluationException</a></code></dd>
</dl>
</li>
</ul>
<a name="toString--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>toString</h4>
<pre>public&nbsp;java.lang.String&nbsp;toString()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
</dl>
</li>
</ul>
<a name="getVariable-java.lang.String-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getVariable</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/RValue.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">RValue</a>&nbsp;getVariable(java.lang.String&nbsp;name,
                          boolean&nbsp;create)</pre>
</li>
</ul>
<a name="getInstance--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInstance</h4>
<pre>public static&nbsp;<a href="../../../../../com/sk89q/worldedit/internal/expression/Expression.html" title="class in com.sk89q.worldedit.internal.expression">Expression</a>&nbsp;getInstance()</pre>
</li>
</ul>
<a name="getFunctions--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFunctions</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/Functions.html" title="class in com.sk89q.worldedit.internal.expression.runtime">Functions</a>&nbsp;getFunctions()</pre>
</li>
</ul>
<a name="getEnvironment--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEnvironment</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/ExpressionEnvironment.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">ExpressionEnvironment</a>&nbsp;getEnvironment()</pre>
</li>
</ul>
<a name="setEnvironment-com.sk89q.worldedit.internal.expression.runtime.ExpressionEnvironment-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setEnvironment</h4>
<pre>public&nbsp;void&nbsp;setEnvironment(<a href="../../../../../com/sk89q/worldedit/internal/expression/runtime/ExpressionEnvironment.html" title="interface in com.sk89q.worldedit.internal.expression.runtime">ExpressionEnvironment</a>&nbsp;environment)</pre>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/internal/expression/ExpressionException.html" title="class in com.sk89q.worldedit.internal.expression"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/internal/expression/Expression.html" target="_top">Frames</a></li>
<li><a href="Expression.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
